/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gmodel;

/**
 *
 * @author prashanth
 */



public class Inference 
{
    private Sentence2 sentence;
    private float[] prevDelta;
    private float[] currDelta;
    
    private int[][] labelSeq;
    
    public Inference(Sentence2 s)
    {
        sentence=s;
        prevDelta=new float[Global.NPtag.length];
        currDelta=new float[Global.NPtag.length];
        labelSeq=new int[Global.NPtag.length][s.length+1];
        
        for (int i=0;i<Global.NPtag.length;i++)
        	labelSeq[i][0]=0;//Label 'S'
        
//        for(int i=1;i<prevDelta.length;i++)
//        {
//            prevDelta[i]=phi(0,0,i);
//        }
        
      //S,B,I,O => I=2 //FIXME: This is a Major Hack!
        prevDelta[0]=0;
        prevDelta[1]=0.5f;
        prevDelta[2]=0;        
        prevDelta[3]=0.5f;
    }
    
    private void getMax(int posn, int s, float[] prevDelta, float[] retval)
    {
        float max=Float.NEGATIVE_INFINITY;
        float curr=0;
        int maxLoc=0;
        
        for(int s1=1; s1<Global.NPtag.length; s1++)            
        {
            curr=prevDelta[s1]*phi(posn, s1,s);
            if(curr>max)
            {
                max=curr;
                maxLoc=s1;
            }
        }
        //System.out.print("xx"+maxLoc+" ");
        
        retval[0]=max;
        retval[1]=maxLoc;
    }
    
    //returns potential for a given feature for the current sentence
    private float phi(int position, int prevLabel, int currLabel)
    {
            //System.out.println("In phi...");
            float retval=0;			
            for (int i=0;i<Global.numFeatures; i++){
                    retval+=Global.weight[i]*sentence.evaluateFeature(i, position, prevLabel,currLabel);
            }
            return (float)(Math.exp(retval));			
           //System.out.println("phi done!!!");
    }
    
    protected int[] runViterbi()
    {       
        float[] max=new float[2];
        
        for(int s=1; s<Global.NPtag.length; s++)            
        {
	        for(int j=0;j<sentence.length;j++)            
	        {
                int posn=j;//+1;
                  
                getMax(posn,s,prevDelta,max);
                
                currDelta[s]=max[0]; //value                              
                labelSeq[s][posn+1]=(int)max[1];//label
                
                //System.out.print(currDelta[s]+" "+labelSeq[s][posn+1]+" | ");
            }
            for(int i=0; i<prevDelta.length;i++)
                prevDelta[i]=currDelta[i];
        }

        //Define the array of final Labels
        int finalLabels[]= new int[sentence.length+1];
        finalLabels[0]=0;
        
        float pStar=currDelta[1];//Assume 'B' is the best guy here...
        finalLabels[sentence.length]=1;
        
        for (int i=2;i<Global.NPtag.length;i++)
        {//And see if I and O agree...
        	if (currDelta[i]>pStar)
        	{
        		pStar=currDelta[i];
        		finalLabels[sentence.length]=i;
        	}        		
        }
        
        for (int t=sentence.length-1;t>0;t--)//t=n-1 to 1
        {
        	finalLabels[t]=labelSeq[finalLabels[t+1]][t+1];
        }
       
        return finalLabels;
    }
    
    public int[] getLabels()
    {
        return runViterbi();
    }
}
